<?php
/**
 * ------------------------------------------------------------------------
 * JA Filter Plugin - Hikashop
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2016 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */
 
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class JFormFieldFilterfields extends JFormFieldJaMegafilter_filterfields
{
	protected $type = 'filterfields';

	function getFieldGroups()
	{
		$class_methods = get_class_methods($this);
		$fl_array = preg_grep('/getJaMegafilterField(.*?)/', $class_methods);
		
		$fieldgroups = array();
		foreach ($fl_array as $value) {
			$array_key = strtolower( substr($value, 20) );
			$group = $this->{ $value }();
			if ($group) {
				$fieldgroups[$array_key] = $group;
			}
		}
		return $fieldgroups;
	}
	
	function getJaMegafilterFieldBaseField()
	{
		$basefield = array(
			array(
				"published"=>0,
				"sort" => 0,
				"field"=> "name",
				"title"=>JText::_("COM_JAMEGAFILTER_TITLE"),
				"name"=>JText::_("COM_JAMEGAFILTER_TITLE"),
				"filter_type"=>array("value")
			),

			array(
				"published"=>0,
				"sort" => 0,
				"field"=> "price",
				"title"=>JText::_("COM_JAMEGAFILTER_PRICE"),
				"name"=>JText::_("COM_JAMEGAFILTER_PRICE"),
				"filter_type"=>array("range")
			),

			
			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "attr.category.value",
				"title"=>JText::_("COM_JAMEGAFILTER_CATEGORY"),
				"name"=>JText::_("COM_JAMEGAFILTER_CATEGORY"),
				"filter_type"=>array("single", "dropdown", "multiple")
			),

			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "attr.badges.value",
				"title"=>JText::_("COM_JAMEGAFILTER_BADGES"),
				"name"=>JText::_("COM_JAMEGAFILTER_BADGES"),
				"filter_type"=>array("single", "dropdown", "multiple")
			),	

			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "attr.brand.value",
				"title"=>JText::_("COM_JAMEGAFILTER_BRAND"),
				"name"=>JText::_("COM_JAMEGAFILTER_BRAND"),
				"filter_type"=>array("single", "dropdown", "multiple")
			),	

			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "attr.tag.value",
				"title"=>JText::_("COM_JAMEGAFILTER_TAG"),
				"name"=>JText::_("COM_JAMEGAFILTER_TAG"),
				"filter_type"=>array("single", "dropdown", "multiple")
			),			

			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "rating",
				"title"=>JText::_("COM_JAMEGAFILTER_RATING"),
				"name"=>JText::_("COM_JAMEGAFILTER_RATING"),
				"filter_type"=>array("range")
			),

			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "width",
				"title"=>JText::_("COM_JAMEGAFILTER_WIDTH"),
				"name"=>JText::_("COM_JAMEGAFILTER_WIDTH"),
				"filter_type"=>array("range")
			),		
			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "length",
				"title"=>JText::_("COM_JAMEGAFILTER_LENGTH"),
				"name"=>JText::_("COM_JAMEGAFILTER_LENGTH"),
				"filter_type"=>array("range")
			),		
			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "height",
				"title"=>JText::_("COM_JAMEGAFILTER_HEIGHT"),
				"name"=>JText::_("COM_JAMEGAFILTER_HEIGHT"),
				"filter_type"=>array("range")
			),		
			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "weight",
				"title"=>JText::_("COM_JAMEGAFILTER_WEIGHT"),
				"name"=>JText::_("COM_JAMEGAFILTER_WEIGHT"),
				"filter_type"=>array("range")
			),		
			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "attr.created_date.value",
				"title"=>JText::_("COM_JAMEGAFILTER_CREATED_DATE"),
				"name"=>JText::_("COM_JAMEGAFILTER_CREATED_DATE"),
				"filter_type"=>array("date")
			),		
			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "attr.modified_date.value",
				"title"=>JText::_("COM_JAMEGAFILTER_MODIFIED_DATE"),
				"name"=>JText::_("COM_JAMEGAFILTER_MODIFIED_DATE"),
				"filter_type"=>array("date")
			),		

		);
		return $basefield;
	}

	function getJaMegafilterFieldCharacteristic()
	{
		$q = 'select * from #__hikashop_characteristic where characteristic_parent_id =  0';
		$db = JFactory::getDbo()->setQuery($q);
		$characteristics = $db->loadObjectList();
		
		if (empty($characteristics)) return;
		
		$characteristic_fields = array();
		foreach ( $characteristics as $char)
		{
				$characteristic_fields[] = array(
					"published" => 0,
					"sort" => 0,	
					"field" => 'attr.char'.$char->characteristic_id.'.value',
					"title" => $char->characteristic_value,
					"name" => $char->characteristic_value,
					"filter_type" => array( "single", "dropdown", "multiple", "color" ) 
					);
		}
		return $characteristic_fields;
	}
	
	function getJaMegafilterFieldCustomFields() {
		$supported_type = array(
			'text' => array('value'), 
			'radio' => array('single', 'dropdown', 'multiple'), 
			'checkbox' => array('single', 'dropdown', 'multiple'), 
			'singledropdown' => array('single', 'dropdown', 'multiple'), 
			'multipledropdown' => array('single', 'dropdown', 'multiple'), 
			'date' => array('date'),
			'zone' => array('single', 'dropdown', 'multiple'),
			);
		
		$db = JFactory::getDbo();
		$query = 'SELECT * FROM #__hikashop_field WHERE field_table = "product" AND field_published = 1';
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		
		$fields = array();
		foreach ($rows as $item) {
			if (in_array($item->field_type, array_keys($supported_type))) {
				$fields[] = array(
					'published' => 0,
					'sort' => 0,
					'field' => 'attr.ct' . $item->field_id . '.value',
					'title' => $item->field_realname,
					'name' => $item->field_realname,
					'filter_type' => $supported_type[$item->field_type]
				);
			}
		}
		return $fields;
	}
}