<?php
/**
 * ------------------------------------------------------------------------
 * JA Filter Plugin - Hikashop
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2016 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */
defined('_JEXEC') or die;
JLoader::register('BaseFilterHelper', JPATH_ADMINISTRATOR .'/components/com_jamegafilter/base.php');

class HikashopFilterHelper extends BaseFilterHelper
{
	protected $menuid = '';
	
	function __construct($params = array())
	{
		return parent::__construct($params);
	}

	function getFilterItems($catid)
	{
		$filterItems = array();
		$langs = JLanguageHelper::getLanguages();
		foreach ($langs AS $lang) {
			$key = str_replace('-', '_', strtolower($lang->lang_code));
			$filterItems[$key] = $this->getItemList($catid, $lang);
		}
		return $filterItems;
	}
	
	function getItemList($catid, $lang)
	{
		$itemList = new stdCLass();
		$catList = $this->getCatList($catid, $lang);
		if (empty($catList)) {
			return array();
		}
		$baseItemList = $this->getBaseItemList( $catList );

		foreach ($baseItemList as $bItem) {
			$item = $this->getItem($bItem, $lang);
			if (!empty($item)) {
				$property = 'item_'.$item->id;
				$itemList->{ $property } = $item;
			}
		}
		return $itemList;
	}
	
	function getBaseItemList($catList)
	{
		$array_id = array();
		foreach ($catList as $cat)
		{
			$array_id[] = $cat->category_id;
		}
		$q = 'select b.product_id from #__hikashop_product_category as a';
		$q .= ' left join #__hikashop_product as b on (a.product_id = b.product_id)';
		$q .= ' where a.category_id in ('.  implode(',', $array_id).') and b.product_published = 1';
		$q .= ' group by a.product_id';
		$q .= ' order by a.product_id desc';
		$db = JFactory::getDbo()->setQuery($q);
		$ids = $db->loadColumn();
		$productClass = hikashop_get('class.product');
		$productClass->getProducts($ids);

		return $productClass->products;
	}
	
	function getItem($baseItem, $lang)
	{
		$item = new stdClass();
		$item->id = $baseItem->product_id;
		$name = '';
		if (defined('FALANG_PATH')) {
			$name = $this->getFaTranslation($lang->lang_id, $item->id, 'hikashop_product', 'product_name');
		} 
		$item->name = $name ? $name : $baseItem->product_name;
		if($baseItem->product_quantity > 0 || $baseItem->product_quantity == -1 ) $item->is_salable = 1;

		$pprice = $this->getPrice($baseItem);
		$item->price = (float) $pprice->price;
		$item->frontend_price = $pprice->frontend_price;
		if (isset($pprice->price_without_discount)) {
			$item->fpricewd = $pprice->frontend_price_without_discount;
		}
		$item->rating = (float) $baseItem->product_average_score;
		$item->width_rating = $baseItem->product_average_score * 20;
		
		$item->attr = array();
		
		if ($this->checkDisplayOnFO('name')) {
			$item->attr['name']['frontend_value'] = $item->name;
			$fieldconfig = $this->getFieldConfig('name');
			$item->attr['name']['title'] = array($fieldconfig['title']);
			$item->attr['name']['type'] = $fieldconfig['type'];
		}

		if ($this->checkDisplayOnFO('price')) {
			$item->attr['price']['frontend_value'] = $item->frontend_price;
			$fieldconfig = $this->getFieldConfig('price');
			$item->attr['price']['title'] = array($fieldconfig['title']);
			$item->attr['price']['type'] = $fieldconfig['type'];
		}

		if ( $this->checkDisplayOnFO('rating')) {
			$item->attr['rating']['frontend_value'] = $item->width_rating;
			$fieldconfig = $this->getFieldConfig('rating');
			$item->attr['rating']['title'] = array($fieldconfig['title']);
			$item->attr['rating']['type'] = $fieldconfig['type'];
		}

		if ($baseItem->product_created) {
			if ($this->checkPublished('attr.created_date.value')) {
				$item->attr['created_date']['value'] = array($baseItem->product_created );
				$item->attr['created_date']['frontend_value'] = array($baseItem->product_created);
			}

			if ($this->checkDisplayOnFO('attr.created_date.value')) {
				$item->attr['created_date']['frontend_value'] = array($baseItem->product_created);
				$fieldconfig = $this->getFieldConfig('attr.created_date.value');
				$item->attr['created_date']['title'] = array($fieldconfig['title']);
				$item->attr['created_date']['type'] = $fieldconfig['type'];
			}
		}
		
		if ($baseItem->product_modified) {
			if ($this->checkPublished('attr.modified_date.value')) {
				$item->attr['modified_date']['value'] = array($baseItem->product_modified);
				$item->attr['modified_date']['frontend_value'] = array($baseItem->product_modified);
			}

			if ($this->checkDisplayOnFO('attr.modified_date.value')) {
				$item->attr['modified_date']['frontend_value'] = array($baseItem->product_modified);
				$fieldconfig = $this->getFieldConfig('attr.modified_date.value');
				$item->attr['modified_date']['title'] = array($fieldconfig['title']);
				$item->attr['modified_date']['type'] = $fieldconfig['type'];
			}
		}

		$this->attr = array();
		$this->addBadgeInfo($baseItem);
		if (!empty($this->attr['badges']['image'])) {
			$item->badgeimg = $this->attr['badges']['image'];
			unset($this->attr['badges']['image']);
		}
		$this->addCategoryInfo($baseItem, $lang);
		$this->addBrandInfo($baseItem, $lang);
		$this->addTagInfo($baseItem, $lang);
		$this->addCharacteristics($baseItem, $lang);
		$this->addCustomFields($baseItem, $lang);
		$item->attr = array_merge($item->attr, $this->attr);
		
		$dimension_unit = $baseItem->product_dimension_unit;
		$weight_unit = $baseItem->product_weight_unit;
		
		$product_weight = $baseItem->product_weight ? +$baseItem->product_weight : 0;
		if ($this->checkPublished('weight')) {
			$item->weight = $product_weight;
		}

		if ($this->checkDisplayOnFO('weight')) {
			$item->attr['weight']['frontend_value'] =  $product_weight .' '. $weight_unit;
			$fieldconfig = $this->getFieldConfig('weight');
			$item->attr['weight']['title'] = array($fieldconfig['title']);
			$item->attr['weight']['type'] = $fieldconfig['type'];
		}
		
		$product_width = $baseItem->product_width ? +$baseItem->product_width : 0 ;
		if ($this->checkPublished('width')) {
			$item->width = $product_width;
		}

		if ($this->checkDisplayOnFO('width')) {
			$item->attr['width']['frontend_value'] = $product_width .' '. $dimension_unit;
			$fieldconfig = $this->getFieldConfig('width');
			$item->attr['width']['title'] = array($fieldconfig['title']);
			$item->attr['width']['type'] = $fieldconfig['type'];
		}

		$product_length = $baseItem->product_length ? +$baseItem->product_length : 0;
		if ($this->checkPublished('length')) {
			$item->length = $product_length;
		}

		if ($this->checkDisplayOnFO('length')) {
			$item->attr['length']['frontend_value'] = $product_length .' '. $dimension_unit;
			$fieldconfig = $this->getFieldConfig('length');
			$item->attr['length']['title'] = array($fieldconfig['title']);
			$item->attr['length']['type'] = $fieldconfig['type'];
		}

		$product_height = $baseItem->product_height ? +$baseItem->product_height : 0;
		if ($this->checkPublished('height')) {
			$item->height = $product_height;
		}

		if ($this->checkDisplayOnFO('height')) {
			$item->attr['height']['frontend_value'] = $product_height .' '. $dimension_unit;
			$fieldconfig = $this->getFieldConfig('height');
			$item->attr['height']['title'] = array($fieldconfig['title']);
			$item->attr['height']['type'] = $fieldconfig['type'];
		}

		$item->url = $this->getUrl($baseItem, $lang);
		$item->menuid = $this->menuid;
		$item->thumbnail = $this->getThumbnail($baseItem);
		return $item;
	}

	function getUrl($baseItem, $lang)
	{
		// use cache
		if (empty($this->menuid))
			$this->menuid = $this->getMenuId($lang);
		$alias = '';
		if (defined('FALANG_PATH')) {
			$alias = $this->getFaTranslation($lang->lang_id, $baseItem->product_id, 'hikashop_product', 'product_alias');
		}
		$product_alias = $alias ? $alias : $baseItem->product_alias;
		$url = 'index.php?option=com_hikashop&ctrl=product&task=show&cid='.$baseItem->product_id.'&name='.$product_alias.$this->menuid;
		return $url;
	}
	
	function getMenuId($lang)
	{
		$helper = new $this;
		$lang_tag = $lang->lang_code;
		$q = 'select id, params from #__menu';
		$q .= ' where ( link = "index.php?option=com_hikashop&view=product&layout=listing" or link = "index.php?option=com_hikashop&view=category&layout=listing")';
		$q .= ' and ( language ="'.$lang_tag.'" or language ="*" ) and published = 1';
		$q .= ' order by link desc';
		$db = JFactory::getDbo()->setQuery($q);
		$helper->menu_list = $db->loadObjectList();
		
		$num_cats_of_menu = array();
		foreach ($helper->menu_list as $menu)
		{
			$helper->catList = array();
			$helper->childCatList = array();
			$params = json_decode($menu->params);
			if (!empty($params->hk_product->category)) 
				$num_cats_of_menu[$menu->id] = count($helper->getChildCatList($params->hk_product->category, $lang));
			elseif (!empty($params->hk_category->category)) 
				$num_cats_of_menu[$menu->id] = count($helper->getChildCatList($params->hk_category->category, $lang));
			else 
				$num_cats_of_menu[$menu->id] = 0;
		}

		if (!empty($num_cats_of_menu)) {
			$menuId = array_search( max($num_cats_of_menu), $num_cats_of_menu );
			return '&Itemid='.$menuId;
		} else 
			return '';
	}
	
	function getThumbnail($baseItem)
	{
		$config = hikashop_config();
		$images = $baseItem->images;
		if (count($images)) {
			return $config->get('uploadfolder') . $images[0]->file_path;
		} elseif (file_exists(JPATH_ROOT  . '/' . $config->get('uploadfolder') . $config->get('default_image'))) {
			return $config->get('uploadfolder') . $config->get('default_image');
		} else {
			return 'media/com_hikashop/images/barcode.png';
		}
	}
	
	function addCharacteristics($baseItem, $lang)
	{
		$ids = $this->getVariantProductId($baseItem);
		array_unshift( $ids, $baseItem->product_id );

		$q  = 'select a.*,b.* from '.hikashop_table('variant').' as a';
		$q .= ' inner join '.hikashop_table('characteristic').' as b on a.variant_characteristic_id=b.characteristic_id';
		$q .= ' where a.variant_product_id in ('.implode(',',$ids).')';
		$q .= ' group by b.characteristic_id';
		$db = JFactory::getDbo()->setQuery($q);
		$result = $db->loadObjectList();
		
		if(empty($result)) return;
		
		$parent = array();
		foreach( $result as $value)
		{
			if ($value->characteristic_parent_id == 0) {
				$parent[] = $value->characteristic_id;
			}
		}

		foreach( $result as $value )
		{
			if (in_array($value->characteristic_parent_id, $parent)) {
				$trans_text = '';
				if (defined('FALANG_PATH')) {
					$trans_text = $this->getFaTranslation($lang->lang_id, $value->characteristic_id, 'hikashop_characteristic', 'characteristic_value');
				}
				$characteristic_value = $trans_text ? $trans_text :  $value->characteristic_value;
				
				$key = 'char'.$value->characteristic_parent_id;
				$published = false;
				if ($this->checkPublished('attr.'.$key.'.value')) {
					$published = true;
					$this->attr[$key]['value'][] = $value->characteristic_id;
					$this->attr[$key]['frontend_value'][] = $characteristic_value;
				}
				
				if ($this->checkDisplayOnFO('attr.'.$key.'.value')) {
					if (!$published) {
						$this->attr[$key]['frontend_value'][] = $characteristic_value;
					}
					$fieldconfig = $this->getFieldConfig('attr.'.$key.'.value');
					$this->attr[$key]['title'] = array($fieldconfig['title']);
					$this->attr[$key]['type'] = $fieldconfig['type'];
				}
			}
		}
		
		return $this->attr;
	}
	
	function getVariantProductId($baseItem)
	{
		$q = 'select product_id from #__hikashop_product';
		$q .= ' where product_published = 1 and product_type = "variant" and product_parent_id ='. (int) $baseItem->product_id;
		$db = JFactory::getDbo()->setQuery($q);
		return $db->loadColumn();
	}
	
	function addTagInfo($baseItem, $lang)
	{
		$helperTags = new JHelperTags();
		$tags = $helperTags->getItemTags('com_hikashop.product',$baseItem->product_id, true);
		
		if (!$tags) {
			return;
		}
		
		$tdata = array();
		foreach ( $tags as $tag)
		{
			$tdata['value'][] = $tag->tag_id;
			$tdata['frontend_value'][] = $this->getTagTreeName($tag);
		}
		
		if ($this->checkPublished('attr.tag.value')) {
			$this->attr['tag'] = $tdata;
		}
		
		if ($this->checkDisplayOnFO('attr.tag.value')) {
			$this->attr['tag']['frontend_value'] = $tdata['frontend_value'];
			$fieldconfig = $this->getFieldConfig('attr.tag.value');
			$this->attr['tag']['title'] = array($fieldconfig['title']);
			$this->attr['tag']['type'] = $fieldconfig['type'];
		}
		
		return $this->attr;
	}

	function getTagTreeName($tag) {
		$q = 'SELECT * FROM `#__tags` WHERE id = ' . $tag->parent_id . ' AND id > 1';
		$db = JFactory::getDbo()->setQuery($q);
		$result = $db->loadObject();
		if ($result) {
			$result->title = $result->title . ' &raquo; ' . $tag->title;
			return $this->getTagTreeName($result);
		} else {
			return $tag->title;
		}
	}
	
	function addBrandInfo($baseItem, $lang)
	{
		if ($baseItem->product_manufacturer_id) {
			$q = 'select * from #__hikashop_category';
			$q .= ' where category_type = "manufacturer" and category_id ='. (int) $baseItem->product_manufacturer_id;
			$q .= ' and category_published = 1';
			$db = JFactory::getDbo()->setQuery($q);
			$result = $db->loadObject();
			
			if (empty($result)) {
				return;
			}

			$trans_text = '';
			if (defined('FALANG_PATH')) {
				$trans_text = $this->getFaTranslation($lang->lang_id, $result->category_id, 'hikashop_category', 'category_name');
			}
			
			$brand_name = $trans_text ? $trans_text : $result->category_name;
			
			if ($this->checkPublished('attr.brand.value')) {
				$this->attr['brand']['value'] = array($result->category_id);
				$this->attr['brand']['frontend_value'] = array($brand_name);
			}
			
			if ($this->checkDisplayOnFO('attr.brand.value')) {
				$this->attr['brand']['frontend_value'] = array($brand_name);
				$fieldconfig = $this->getFieldConfig('attr.brand.value');
				$this->attr['brand']['title'] = array($fieldconfig['title']);
				$this->attr['brand']['type'] = $fieldconfig['type'];
			}
		}
		return $this->attr;
	}
	
	function addCategoryInfo($baseItem, $lang)
	{
		$catTree = $this->getCatTree($this->catList);
		$cdata = array();
		if ($catTree) {
			foreach( $catTree as $singleCat)
			{
				if (in_array($singleCat->category_id, $baseItem->categories)) {
					$cdata['value'][] = $singleCat->category_id;
					$cdata['frontend_value'][] = $singleCat->category_name;
				}
			}
			
			if (!$cdata) {
				return;
			}
			
			if ($this->checkPublished('attr.category.value')) {
				$this->attr['category'] = $cdata;
			}
			if ($this->checkDisplayOnFO('attr.category.value')) {
				$this->attr['category']['frontend_value'] = $cdata['frontend_value'];
				$fieldconfig = $this->getFieldConfig('attr.category.value');
				$this->attr['category']['title'] = array($fieldconfig['title']);
				$this->attr['category']['type'] = $fieldconfig['type'];
			}
			return $this->attr;
		}
	}
	
	function addBadgeInfo($baseItem)
	{
		$config = hikashop_config();
		$badgeClass = hikashop_get('class.badge');
		$badgeClass->loadBadges($baseItem);
		if ($baseItem->badges) {
			$bdata = array();
			foreach ($baseItem->badges as $badge) {
				$bdata['value'][] = $badge->badge_id;
				$bdata['frontend_value'][] = $badge->badge_name;
			}
			if ($this->checkPublished('attr.badges.value')) {
				$this->attr['badges'] = $bdata;
			}
			
			if ($this->checkDisplayOnFO('attr.badges.value')) {
				$this->attr['badges']['image'] = $badge->badge_image ? $config->get('uploadfolder') . $badge->badge_image : $config->get('uploadfolder') . $config->get('default_image') ;
			}
		}
		return	$this->attr;
	}
	
	function getPrice($baseItem)
	{
		$pprice = new stdClass();
		$currency_id = hikashop_getCurrency();
		$currencyClass = hikashop_get('class.currency');
		$config = hikashop_config();
		$main_currency = (int) $config->get('main_currency', 1);
		$zone_id = hikashop_getZone(null);
		$discount_before_tax = (int) $config->get('discount_before_tax', 0);
		$ids = array($baseItem->product_id);
		$currencyClass->getPrices($baseItem, $ids, $currency_id, $main_currency, $zone_id, $discount_before_tax);
		$currency = $this->getCurrency($currency_id);
		
		if ($baseItem->prices) {
			$p = array();
			foreach ($baseItem->prices as $price) {
				$p[] = $price->price_value_with_tax;
			}
			$pprice->price = min($p);

			if (isset($baseItem->discount)) {
				$pprice->price_without_discount = $pprice->price / (100 - $baseItem->discount->discount_percent_amount) * 100;
			}

		} elseif ($baseItem->variants) {
			$p = array();
			$discount = 100;
			foreach ($baseItem->variants as $variant) {
				if ($variant->discount) {
					$discount = $variant->discount->discount_percent_amount;
				}

				$dp = $variant->product_sort_price * (100- $discount) / 100 ;
				if ($dp) {
					$p[] = $dp;
				}
			}

			if ($p) {
				$pprice->price = min($p);
			} else {
				$pprice->price = 0;
			}
			
			if ($discount != 100) {
				$pprice->price_without_discount = $pprice->price  / (100 - $discount) * 100;
			}
		} else {
			$pprice->price = 0;
		}
		
		if ($pprice->price) {
			$pformated = $currencyClass->format($pprice->price, $currency_id);
			$pprice->frontend_price = str_replace($currency, '<span class="currency">' . $currency . '</span>', $pformated);
		} else {
			$pprice->frontend_price = JText::_('COM_JAMEGAFILTER_FREE');
		}
		
		if (isset($pprice->price_without_discount)) {
			$pformated = $currencyClass->format($pprice->price_without_discount, $currency_id);
			$pprice->frontend_price_without_discount = str_replace($currency, '<span class="currency">' . $currency . '</span>', $pformated);
		}

		return $pprice;
	}

	function getCurrency($currency_id) {
		$q = 'SELECT * FROM `#__hikashop_currency` WHERE currency_id ='.$currency_id;
		$db = JFactory::getDbo()->setQuery($q);
		$obj = $db->loadObject();
		switch ($obj->currency_format) {
			case '%n':
				return $obj->currency_symbol;
			
			case '%i':
				return $obj->currency_code;
		}
	}
	
	function getFaTranslation($lang_id = 0, $reference_id = 0, $reference_table = 'table', $reference_field = 'field') {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('value'))
				->from($db->quoteName('#__falang_content'))
				->where($db->quoteName('reference_id') . '=' . $db->quote($reference_id))
				->where($db->quoteName('reference_table') . '=' . $db->quote($reference_table))
				->where($db->quoteName('reference_field') . '=' . $db->quote($reference_field))
				->where($db->quoteName('language_id') . '=' . $db->quote($lang_id))
				->where($db->quoteName('published') . '=' . $db->quote(1));
		$db->setQuery($query);
		return $db->loadResult();
	}
	
	function getCatList($catid, $lang)
	{
		$this->catList = array();
		$this->childCatList = array();
		$q = 'select category_id, category_parent_id, category_name, category_depth';
		$q .= ' from #__hikashop_category';
		$q .= ' where category_type="product" and category_published = 1 and category_id ='. (int) $catid;
		$db = JFactory::getDbo()->setQuery($q);
		$result = $db->loadObject();
		$this->catList = $this->getChildCatList($catid, $lang);
		if($catid != 1 && $result) {
			if (defined('FALANG_PATH')) {
				$name = $this->getFaTranslation($lang->lang_id, $result->category_id, 'hikashop_category', 'category_name');
				if ($name) {
					$result->category_name = $name;
				}
			}
			array_unshift($this->catList, $result);
		}
		return $this->catList;
	}
	
	function getChildCatList ($catid, $lang)
	{
		$q = 'select category_id, category_parent_id, category_name, category_depth';
		$q .= ' from #__hikashop_category ';
		$q .= ' where category_type = "product" and category_parent_id = ' .(int) $catid;
		$q .= ' and category_published = 1';
		$db = JFactory::getDbo();
		$db->setQuery($q);
		$list = $db->loadObjectList();
		foreach ( $list as $item )
		{
			if (defined('FALANG_PATH')) {
				$name = $this->getFaTranslation($lang->lang_id, $item->category_id, 'hikashop_category', 'category_name');
				if ($name) {
					$item->category_name = $name;
				}
			}
			$this->childCatList[] = $item;
			$this->getChildCatList($item->category_id, $lang);
		}
		return $this->childCatList;
	}
	
	function getCatTree($catList)
	{
		$catTree = array();
		foreach ( $catList as $cat )
		{
			$nametree = '';
			$tcat = clone $cat;
			foreach( $catTree as $singleCat ) 
			{
				if ($cat->category_parent_id == $singleCat->category_id) {
					$nametree = $singleCat->category_name.' &raquo; '.$nametree;
					break;
				} 
			}

			$tcat->category_name = $nametree . $cat->category_name;
			array_push($catTree, $tcat);
		}
		return $catTree;
	}
	
	function addCustomFields($item, $lang) {
		$fieldClass = hikashop_get('class.field');
		$fields = $fieldClass->getFields('backend', $item, 'product');
		if (empty($fields)) {
			return;
		}
		$data = array();
		foreach ($fields as $field) {
			if (empty($item->{$field->field_namekey})) {
				continue;
			}
			$val = $item->{$field->field_namekey};
			
			$key = 'ct' . $field->field_id;
			switch ($field->field_type) {
				case 'text':
					$data[$key]['value'] = $val;
					$data[$key]['frontend_value'] = $val;
					break;
				
				case 'radio':
				case 'checkbox':
				case 'singledropdown':
				case 'multipledropdown':
				case 'zone':
					$array = explode(',', $val);
					foreach ($array as $i) {
						foreach ($field->field_value as $k => $v) {
							if ($i == $k) {
								$data[$key]['value'][] = $k;
								$data[$key]['frontend_value'][] = $v->value;
							}
						}
					}
					
					break;
				
				case 'date':
					$data[$key]['value'][] = strtotime($val);
					$data[$key]['value'][] = strtotime($val);
					break;
				default:
					break;
			}
		}

		foreach ($data as $k => $f) {
			if ($this->checkPublished('attr.'.$k.'.value')) {
				$this->attr[$k] = $f;
			}

			if ($this->checkDisplayOnFO('attr.'.$k.'.value')) {
				$this->attr[$k]['frontend_value'] = $f['frontend_value'];
				$fieldconfig = $this->getFieldConfig('attr.'.$k.'.value');
				$this->attr[$k]['title'] = array($fieldconfig['title']);
				$this->attr[$k]['type'] = $fieldconfig['type'];
			}
		}
	} 
}