<?php
/**
 * ------------------------------------------------------------------------
 * JA Filter Plugin - Hikashop
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2016 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */

defined('_JEXEC') or die;

if(!defined('DS')) define('DS', DIRECTORY_SEPARATOR);
if (file_exists(JPATH_ADMINISTRATOR.'/components/com_hikashop/helpers/helper.php'))
	require_once(JPATH_ADMINISTRATOR.'/components/com_hikashop/helpers/helper.php');

// Initiate class to hold plugin events
class plgJamegafilterHikashop extends JPlugin {

	// Some params
	public $pluginName = 'jamegafilter_hikashop';
	public $pluginNameHumanReadable = 'JA Megafilter Hikashop Plugin';
	public $menu_list = array();

	function __construct( & $subject, $params) {
		parent::__construct($subject, $params);
	}

	function onAfterSaveHikashopItems($item) {
		require_once (__DIR__.'/helper.php');
		$params = $item->params;
		$helper = new HikashopFilterHelper($params);
		$objectList = $helper->getFilterItems($params['hikacat']);
		return $objectList;
	}
	
	function onBeforeDisplayHikashopItems( $jstemplate, $filter_config, $item )
	{
		$this->jstemplate = $jstemplate;
		$this->config = $filter_config;
		$this->item = $item;
		$input = JFactory::getApplication()->input;
		$jalayout = $input->get('jalayout', 'default');
		$path = JPluginHelper::getLayoutPath('jamegafilter', 'hikashop', $jalayout);
		
		ob_start();
		include $path;
		$output = ob_get_contents();
		ob_end_clean();
		echo $output;
	}

	public function _getCheckoutURL(){
		$app = JFactory::getApplication();
		$menu = $app->getMenu()->getActive();
		$url_itemid='';
		if(!empty($menu->id)){
			$url_itemid='&Itemid='.$menu->id;
		}
		return hikashop_completeLink('checkout'.$url_itemid,false,true);
	}

	public function init($cart=false){
		$config = hikashop_config();
		$url = $config->get('redirect_url_after_add_cart','stay_if_cart');
		switch($url){
			case 'checkout':
				$url = $this->_getCheckoutURL();
				break;
			case 'stay_if_cart':
				$url='';
				if(!$cart){
					$url = $this->_getCheckoutURL();
					break;
				}
			case 'ask_user':
			case 'stay':
				$url='';
			case '':
			default:
				if(empty($url)){
					$url = hikashop_currentURL('return_url');
				}
				break;
		}

		return urlencode($url);
	}

	
	
}