<?php
/**
 * ------------------------------------------------------------------------
 * JA Filter Plugin - Hikashop
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2016 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */

defined('_JEXEC') or die('Restricted access');

$config = hikashop_config();
$values = $config->values;
$hikashop_version = $values['version']->config_value;

if (version_compare($hikashop_version, '3.0') < 0 ) {
	$addToCartJs = '';
} else {
	$cartHelper = hikashop_get('helper.cart');
	$addToCartJs = $cartHelper->getJS($this->init());
}

$input = JFactory::getApplication()->input;
$direction = !empty($this->config->Moduledirection) ? $this->config->Moduledirection : $this->config->direction;
if ($direction == 'vertical')
	$direction='';

if((!empty($this->config->isComponent) && empty($this->config->isModule)) ||
				(empty($this->config->isComponent) && !empty($this->config->isModule)) ) {
	JHtml::_('formbehavior.chosen', 'select');

	$json = @file_get_contents(JPATH_SITE.$this->config->json);
	$list = (array) json_decode($json);
	$sefUrl = array();
	foreach ( $list as $i)
	{
		$sefUrl[$i->id] = hikashop_contentLink($i->url, $item, false, false, true);
	}
}
?>
<?php if($config->get('show_compare')): ?>
<script type="text/javascript">
var compare_list = {};
window.hikashop.ready(function(){
try{
	document.querySelectorAll('input.hikashop_compare_checkbox').forEach(function(el){
		el.checked = false;
	});
}catch(e){}
});
window.Oby.registerAjax('compare.updated', function(evt){
	var d = document, w = window, o = w.Oby,
		btn = d.getElementById('hikashop_compare_button');
	if(evt.list) {
		compare_list = evt.list;
	}
	if(!btn) return;
	btn.style.display = (evt.size == 0) ? 'none': '';
	if(evt.added && (evt.size == 0 || evt.size < <?php echo (int)$config->get('compare_limit', 5); ?>))
		return true;
	if(!evt.added && evt.size >= <?php echo (int)$config->get('compare_limit', 5); ?>)
		return true;
	var elems = d.querySelectorAll('[data-addToCompare]'), v = null;
	if(!elems) return true;
	elems.forEach(function(e){
		if(!evt.added) {
			e.removeAttribute('disabled');
			o.removeClass(e,'disabled');
			return;
		}
		v = e.getAttribute('data-addToCompare');
		if(evt.list.hasOwnProperty(v))
			return;
		e.setAttribute('disabled', 'disabled');
		o.addClass(e,'disabled');
	});
	return true;
});
</script>
<?php endif; ?>

<?php if(!empty($this->config->isComponent) && empty($this->config->isModule)): ?>
<?php	
	$hasModule = JaMegafilterHelper::hasMegafilterModule(); 
	if($hasModule) {
		$this->config->sticky = 0; 
	} 
?>
<?php if (isset($this->item['mparams']) && $this->item['mparams']->get('show_page_heading')) : ?>
<div class="page-header">
	<h1> <?php echo $this->item['mparams']->get('page_heading'); ?> </h1>
</div>
<?php endif; ?>
<div class="row <?php echo $this->item['type'] ?> <?php echo $direction; ?> ja-megafilter-wrap clearfix">
	<?php if(!empty($this->config->fullpage) && !$hasModule): ?>
		<div data-mgfilter="hikashop" class="<?php echo $direction ?> ja-mg-sidebar sidebar-main col">
			<a href="javascript:void(0)" class="sidebar-toggle">
				<span class="filter-open">
					<i class="fa fa-filter"></i><?php echo JText::_('COM_JAMEGAFILTER_OPEN_FILTER'); ?>
				</span>
				<span class="filter-close">
					<i class="fa fa-close"></i><?php echo JText::_('COM_JAMEGAFILTER_CLOSE_FILTER'); ?>
				</span>
			</a>
			<div class="block ub-layered-navigation-sidebar sidebar-content"></div>
		</div>
	<?php endif; ?>
	<?php 
		if ($hasModule || (empty($this->config->fullpage) && !$hasModule)) {
			$full_width = 'full-width';
		} else {
			$full_width = '';
		}
	?>
	<div class="main-content col <?php echo $full_width ?>"></div>
</div>
<?php else: ?>
	<div data-mgfilter="hikashop" class="<?php echo $direction ?> ja-mg-sidebar sidebar-main col">
		<div class="block ub-layered-navigation-sidebar sidebar-content"></div>
		<?php if(empty($this->config->isComponent)): ?>
			<a id="jamegafilter-search-btn" class="btn btn-default " href="javascript:void(0)"><?php echo JText::_('COM_JAMEGAFILTER_SEARCH') ?></a>
		<?php endif;?>
	</div>	
<?php endif; ?>

<?php if((!empty($this->config->isComponent) && empty($this->config->isModule)) ||
				(empty($this->config->isComponent) && !empty($this->config->isModule)) ): ?>

<script type="text/javascript">

<?php if(!empty($this->config->url)): ?>
var filter_url = '<?php echo $this->config->url?>';
<?php endif; ?>
	
var sefUrl = <?php echo json_encode($sefUrl) ?>;
var ja_default_sort="<?php echo $this->config->default_sort; ?>";
var ja_sort_by="<?php echo $this->config->sort_by; ?>";
var ja_layout_addition="<?php echo $this->config->layout_addition; ?>";
var ja_layout_columns=<?php echo json_encode($this->config->jacolumn); ?>;
var p = <?php echo json_encode($this->jstemplate); ?>;
for (var key in p) {
  if (p.hasOwnProperty(key)) {
    var compiled = dust.compile(p[key], key);
    dust.loadSource(compiled);
  }
}

function bindCallback() {
	setTimeout(function(){
		initScript();
	}, 100);
}

function scrolltop() {
	if (!isMobile.phone) jQuery("html, body").stop().animate({ scrollTop: jQuery('div.ja-megafilter-wrap').offset().top }, 400);
}

function MegaFilterCallback() {
	// reset compare list hikashop 
	if (hikashop.compare_list) {
	    hikashop.compare_list = {};
		jQuery('a.hikashop_compare_zone').hide();
	}
	
	bindCallback();
	<?php echo $input->getCmd('scrolltop') ? 'scrolltop()':'' ?>
}

function afterGetData(item) {
	item.url = sefUrl[item.id];
	<?php if (version_compare($hikashop_version, '3.0') < 0): ?>
	item.isNewHikashop = false;
	<?php else: ?>
	item.isNewHikashop = true;
	<?php endif; ?>
}

jQuery(document).ready(function() {
  var UBLNConfig = {};
  UBLNConfig.dataUrl = "<?php echo JUri::base(true).$this->config->json;  ?>";
  UBLNConfig.fields = <?php echo json_encode($this->config->fields); ?>;
  UBLNConfig.sortByOptions = <?php echo str_replace('.value','.frontend_value',json_encode($this->config->sorts)); ?>;
  UBLNConfig.defaultSortBy = "<?php echo $this->config->default_sort; ?>";
  UBLNConfig.productsPerPageAllowed = [<?php echo implode(',', $this->config->paginate); ?>];
  UBLNConfig.autopage = <?php echo $this->config->autopage ? 'true':'false' ?>;
  UBLNConfig.sticky = <?php echo $this->config->sticky ? 'true':'false' ?>;
  UBLN.main(UBLNConfig);
  MegaFilterCallback();
});
</script>
<?php 
endif;